# Copyright 2023 Akretion - Raphaël Valyi <raphael.valyi@akretion.com>
# License LGPL-3.0 or later (https://www.gnu.org/licenses/lgpl-3.0.en.html).
# Generated by https://github.com/akretion/xsdata-odoo
#
from odoo import fields, models

__NAMESPACE__ = "http://tempuri.org/PurchaseOrderSchema.xsd"


class Usaddress(models.AbstractModel):
    _description = "USAddress"
    _name = "poxsd.10.usaddress"
    _inherit = "spec.mixin.poxsd"
    _binding_type = "Usaddress"

    poxsd10_name = fields.Char(string="name", xsd_required=True)

    poxsd10_street = fields.Char(string="street", xsd_required=True)

    poxsd10_city = fields.Char(string="city", xsd_required=True)

    poxsd10_state = fields.Char(string="state", xsd_required=True)

    poxsd10_zip = fields.Float(string="zip", xsd_required=True, xsd_type="xsd:decimal")

    poxsd10_country = fields.Char(string="country", xsd_type="xsd:NMTOKEN")


class Comment(models.AbstractModel):
    _description = "comment"
    _name = "poxsd.10.comment"
    _inherit = "spec.mixin.poxsd"
    _binding_type = "Comment"

    poxsd10_value = fields.Char(string="value", xsd_required=True)


class Items(models.AbstractModel):
    _description = "Items"
    _name = "poxsd.10.items"
    _inherit = "spec.mixin.poxsd"
    _binding_type = "Items"

    poxsd10_item = fields.One2many(
        "poxsd.10.item", "poxsd10_item_Items_id", string="item"
    )


class Item(models.AbstractModel):
    _description = "item"
    _name = "poxsd.10.item"
    _inherit = "spec.mixin.poxsd"
    _binding_type = "Items.Item"

    poxsd10_item_Items_id = fields.Many2one(
        comodel_name="poxsd.10.items", xsd_implicit=True, ondelete="cascade"
    )
    poxsd10_productName = fields.Char(string="productName", xsd_required=True)

    poxsd10_quantity = fields.Integer(string="quantity", xsd_required=True)

    poxsd10_USPrice = fields.Float(
        string="USPrice", xsd_required=True, xsd_type="xsd:decimal"
    )

    poxsd10_comment = fields.Many2one(comodel_name="poxsd.10.comment", string="comment")

    poxsd10_shipDate = fields.Date(string="shipDate")

    poxsd10_partNum = fields.Char(string="partNum", xsd_required=True, xsd_type="x:SKU")


class PurchaseOrderType(models.AbstractModel):
    _description = "PurchaseOrderType"
    _name = "poxsd.10.purchaseordertype"
    _inherit = "spec.mixin.poxsd"
    _binding_type = "PurchaseOrderType"

    poxsd10_shipTo = fields.Many2one(
        comodel_name="poxsd.10.usaddress",
        string="shipTo",
        xsd_required=True,
        xsd_type="x:USAddress",
    )

    poxsd10_billTo = fields.Many2one(
        comodel_name="poxsd.10.usaddress",
        string="billTo",
        xsd_required=True,
        xsd_type="x:USAddress",
    )

    poxsd10_comment = fields.Many2one(comodel_name="poxsd.10.comment", string="comment")

    poxsd10_items = fields.Many2one(
        comodel_name="poxsd.10.items",
        string="items",
        xsd_required=True,
        xsd_type="x:Items",
    )

    poxsd10_orderDate = fields.Date(string="orderDate")
